Subject: Re: [PATCH 1/2] remote: add camel-cased *.tagOpt key, like clone

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Thu, 25 Feb 2021 20:47:35 +0100

On Thu, Feb 25 2021, Junio C Hamano wrote:

> Ævar Arnfjörð Bjarmason  <[email-masked]> writes:
>
>> It's easy enough to add a test for this, so let's do that. We can't
>> use "git config -l" there, because it'll normalize the keys to their
>> lower-cased form.
>
> I wondered if we want "git config -l --preserve-case" or something
> like that, but an extra grep for "tagOpt" would be sufficient in a
> simple test like these that are unlikely to have unrelated tagOpt
> defined in the file.  More importantly, I am starting to doubt if
> this should even be tested.
>
> If there were existing "section.varname" variable definition and we
> ask
>
> 	git_config_set("section.varName", "newvalue");
>
> we may end up with "[section] varname = newvalue", and that is
> perfectly OK, I would think, because the first and the last
> component of the configuration variable names are defined to be case
> insensitive, and here may be "[Section] varname = oldvalue" in the
> configuration file before we try to set it, and the implementation
> is free to replace "oldvalue" with "newvalue", instead of first
> removing "[Section] varname = oldvalue" and then adding a new
> "[section] varName = newvalue" (after all, there may be variables
> other than "varname" in the section, and the existing "[Section]"
> header may need to be kept for the remaining variables while we futz
> with the varname or varName).
>
> Which means that while we do want to spell the names in our source
> code correctly (i.e. "tagOpt", not "tagopt") when we tell which
> variable we want to get modified to the git_config_set() function,
> we should not care how exactly git_config_set() chooses to spell the
> variable in the resulting configuration file, no?
>
> So, ...

Yes, in general, but...

>> diff --git a/t/t5612-clone-refspec.sh b/t/t5612-clone-refspec.sh
>> index 6a6af7449ca..3126cfd7e9d 100755
>> --- a/t/t5612-clone-refspec.sh
>> +++ b/t/t5612-clone-refspec.sh
>> @@ -97,6 +97,7 @@ test_expect_success 'by default no tags will be kept updated' '
>>  test_expect_success 'clone with --no-tags' '
>>  	(
>>  		cd dir_all_no_tags &&
>> +		grep tagOpt .git/config &&
>>  		git fetch &&
>>  		git for-each-ref refs/tags >../actual
>
> ...as long as "git config remote.origin.tagopt" yields what we
> expect, we should be OK, I would think.  Insisting that the variable
> name is kept by git_config_set() API may be expecting too much.
>
>>  	) &&

...the cases fixed in this series are not ones where we're possibly
changing an existing variable name, but where we're guaranteed to be
writing new values.

We are renaming a remote or otherwise moving variables around, if there
were existing values to contend with we'd have died earlier.

I'm not quite sure what to make of this feedback in general. That you'd
like the bugfix but we shouldn't bother with a regression test, or that
we shouldn't bother with the fix at all?

I admit this is getting to diminishing returns in testing, we're
unlikely to break this, and if we do it's not such a big deal.

But I don't agree that we should feel free to munge user config files
within the bound of valid config syntax when we edit these files for
users.

We already go out of our way to add values to existing sections, not add
new empty headings etc. (I believe the last major effort on that front
was from Johannes S. a while back).

likewise here, even though cmd.averylongvariablename is perfectly valid,
it's much more user friendly if we write/edit it as
cmd.AVeryLongVariableName.